// Code generated by mdatagen. DO NOT EDIT.

package metadata

import "go.opentelemetry.io/collector/confmap"

// MetricConfig provides common config for a particular metric.
type MetricConfig struct {
	Enabled bool `mapstructure:"enabled"`

	enabledSetByUser bool
}

func (ms *MetricConfig) Unmarshal(parser *confmap.Conf) error {
	if parser == nil {
		return nil
	}
	err := parser.Unmarshal(ms, confmap.WithErrorUnused())
	if err != nil {
		return err
	}
	ms.enabledSetByUser = parser.IsSet("enabled")
	return nil
}

// MetricsConfig provides config for k8s/statefulset metrics.
type MetricsConfig struct {
	K8sStatefulsetCurrentPods MetricConfig `mapstructure:"k8s.statefulset.current_pods"`
	K8sStatefulsetDesiredPods MetricConfig `mapstructure:"k8s.statefulset.desired_pods"`
	K8sStatefulsetReadyPods   MetricConfig `mapstructure:"k8s.statefulset.ready_pods"`
	K8sStatefulsetUpdatedPods MetricConfig `mapstructure:"k8s.statefulset.updated_pods"`
}

func DefaultMetricsConfig() MetricsConfig {
	return MetricsConfig{
		K8sStatefulsetCurrentPods: MetricConfig{
			Enabled: true,
		},
		K8sStatefulsetDesiredPods: MetricConfig{
			Enabled: true,
		},
		K8sStatefulsetReadyPods: MetricConfig{
			Enabled: true,
		},
		K8sStatefulsetUpdatedPods: MetricConfig{
			Enabled: true,
		},
	}
}

// ResourceAttributeConfig provides common config for a particular resource attribute.
type ResourceAttributeConfig struct {
	Enabled bool `mapstructure:"enabled"`
}

// ResourceAttributesConfig provides config for k8s/statefulset resource attributes.
type ResourceAttributesConfig struct {
	K8sNamespaceName       ResourceAttributeConfig `mapstructure:"k8s.namespace.name"`
	K8sStatefulsetName     ResourceAttributeConfig `mapstructure:"k8s.statefulset.name"`
	K8sStatefulsetUID      ResourceAttributeConfig `mapstructure:"k8s.statefulset.uid"`
	OpencensusResourcetype ResourceAttributeConfig `mapstructure:"opencensus.resourcetype"`
}

func DefaultResourceAttributesConfig() ResourceAttributesConfig {
	return ResourceAttributesConfig{
		K8sNamespaceName: ResourceAttributeConfig{
			Enabled: true,
		},
		K8sStatefulsetName: ResourceAttributeConfig{
			Enabled: true,
		},
		K8sStatefulsetUID: ResourceAttributeConfig{
			Enabled: true,
		},
		OpencensusResourcetype: ResourceAttributeConfig{
			Enabled: true,
		},
	}
}

// MetricsBuilderConfig is a configuration for k8s/statefulset metrics builder.
type MetricsBuilderConfig struct {
	Metrics            MetricsConfig            `mapstructure:"metrics"`
	ResourceAttributes ResourceAttributesConfig `mapstructure:"resource_attributes"`
}

func DefaultMetricsBuilderConfig() MetricsBuilderConfig {
	return MetricsBuilderConfig{
		Metrics:            DefaultMetricsConfig(),
		ResourceAttributes: DefaultResourceAttributesConfig(),
	}
}
